unit RxThread;

interface

uses
  Classes,windows,StdCtrls,rs232c,
  Messages, SysUtils, Variants, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Buttons;

type
  TRxThread = class(TThread)
  private
    { Private 錾 }
    Frs232c: Trs232c;
    FMemo: TMemo;
    t:string;

    procedure receiveChar;

  protected
    procedure Execute; override;

  public
    Mode: word;
    constructor Create(rs232c: Trs232c; memo: TMemo); virtual;

  end;  // RSThread

implementation

uses main;
//------------------------------------------------------------------------------
constructor TRxThread.Create(rs232c:Trs232c; memo:Tmemo);
begin
  Frs232c := rs232c;
  FMemo := memo;
  Mode:=1;
  t:='';
  inherited Create(False);
  FreeOnTerminate := True;
end;

//------------------------------------------------------------------------------

procedure TRxThread.receiveChar;
var moji:char;
begin
  if Frs232c.rxdatalen>0 then begin
   Frs232c.rsreadchar(moji);
      case mode of
      1: begin
          if moji=#13 then begin
            Fmemo.Lines.Add('');
          end else Fmemo.Lines[Fmemo.Lines.Count-1]:=
            Fmemo.Lines[Fmemo.Lines.Count-1]+moji;
        end;

      2: begin
           if moji=#13 then begin
             Fmemo.Lines.Add(t);
             t:='';
           end else t:=t+moji;
         end;
      end; // case
  end;
end;

//------------------------------------------------------------------------------

procedure TRxThread.Execute;
begin
  { ToDo : XbhƂĎsR[hɋLq }
  while (not terminated) do begin
    Synchronize(receiveChar);
    sleep(1);
  end;
end;
//------------------------------------------------------------------------------
end.
