unit USBRxThread;

interface

uses
  Classes,windows,StdCtrls,D2XXUnit,
  Messages, SysUtils, Variants, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Buttons, ppgCompiler;

type
  TUSBRxThread = class(TThread)
  private
    { Private 錾 }
    FHandle: DWord;
    FMemo: TMemo;
    t,t2,t3:string;
    FFT_In_Buffer: array[0..$10000-1] of byte;
    FRead_Result: integer;
    accumFinished: boolean;

    moji:char;
    FT_Q:DWord;

    sLine:string;
    procedure addLine;
    procedure refleshLine;

  //  procedure receiveChar;

  protected
    procedure Execute; override;

  public
    Mode: word;
    constructor Create(Handle:DWord; memo: TMemo); virtual;
    property lastSentense: string read t;
    property secondLastSentense: string read t2;
    property thirdLastSentense: string read t3;
  end;  // RSThread

implementation

uses main;
//------------------------------------------------------------------------------
constructor TUSBRxThread.Create(Handle:DWord; memo:Tmemo);
begin
  FHandle := Handle;
  FMemo := memo;
  Mode:=1;
  t:=''; t2:=''; t3:='';
  sLine:='';
  accumfinished:=false;
  inherited Create(False);
  FreeOnTerminate := True;
end;

//------------------------------------------------------------------------------
procedure TUSBRxThread.addLine;
begin
  Fmemo.Lines.Add(sLine);
end;
//------------------------------------------------------------------------------
procedure TUSBRxThread.refleshLine;
begin
  Fmemo.Lines[Fmemo.Lines.Count-1]:=
               Fmemo.Lines[Fmemo.Lines.Count-1]+moji;
end;
//------------------------------------------------------------------------------
//procedure TUSBRxThread.receiveChar;
//var moji:char;
//    FT_Q:DWord;
//begin

//  FT_GetQueueStatus(FHandle, @FT_Q);

//  if FT_Q>0 then begin
//    FT_Read(FHandle,@FFT_In_Buffer,1,@FRead_Result);
//    moji:=Chr(FFT_In_Buffer[0]);
//      case mode of
//      0: begin
//           if moji=#13 then USBRxLineReceived:=true;

//         end;
//      1: begin
//          if moji=#13 then begin
//            Fmemo.Lines.Add('');
//            t3:=t2;
//            t2:=t;
//            t:='';
//            USBRxLineReceived:=true;
//          end else begin
//            Fmemo.Lines[Fmemo.Lines.Count-1]:=
//               Fmemo.Lines[Fmemo.Lines.Count-1]+moji;
//            t:=t+moji;
//          end;
//        end;

//      2: begin
//           if moji=#13 then begin
//            Fmemo.Lines.Add(t);
//             t3:=t2;
//             t2:=t;
//             t:='';
//             USBRxLineReceived:=true;
//           end else t:=t+moji;
//         end;

//      3: begin
//           if moji=#13 then USBRxLineReceived:=true;
//           FMemo.Lines.Add(IntToStr(FFT_In_Buffer[0]));
//         end;

//      end; // case

//      if (runQ) and (moji='*') then begin  {PPGsII}
  //      MainForm.stopButton.Enabled:=false;
//        accumfinished:=true;
//      end;

//  end;
//end;

//------------------------------------------------------------------------------

procedure TUSBRxThread.Execute;
begin
  { ToDo : XbhƂĎsR[hɋLq }
  while (not terminated) do begin
    while (not accumfinished) do begin
      FT_GetQueueStatus(FHandle, @FT_Q);

      if FT_Q>0 then begin
        FT_Read(FHandle,@FFT_In_Buffer,1,@FRead_Result);
        moji:=Chr(FFT_In_Buffer[0]);
      case mode of
        0: begin
             if moji=#13 then USBRxLineReceived:=true;

           end;
        1: begin
            if moji=#13 then begin
              sLine:='';
              synchronize(addLine);
              t3:=t2;
              t2:=t;
              t:='';
              USBRxLineReceived:=true;
            end else begin
              synchronize(refleshLine);
              t:=t+moji;
            end;
          end;

        2: begin
             if moji=#13 then begin
               sLine:=t;
               synchronize(addLine);
               t3:=t2;
               t2:=t;
               t:='';
               USBRxLineReceived:=true;
             end else t:=t+moji;
           end;

      3: begin
             if moji=#13 then USBRxLineReceived:=true;
             sLine:= IntToStr(FFT_In_Buffer[0]);
             synchronize(addLine);
           end;

      end; // case

      if (runQ) and (moji='*') then begin  {PPGsII}
        accumfinished:=true;
      end;

      end; // if FT_Q>0

      sleep(1);

    end; // while

    accumfinished:=false;
    runQ:=false;
    FIDTransfer.Terminate;
    arrayOperation;

    Sleep(1);

  end;
end;
//------------------------------------------------------------------------------
end.
